package main

import (
	"flag"
	"fmt"
	"io/ioutil"
	"runtime"
)

var (
	fname string
)

func init() {
	runtime.GOMAXPROCS(runtime.NumCPU())
	flag.StringVar(&fname, "fname", "", "name of the file to be chunked")
}

func main() {
	flag.Parse()
	fmt.Printf("Attempting to read %s\n", fname)
	file, err := ioutil.ReadFile(fname)
	if err != nil {
		fmt.Println(err)
		return
	}
	l := len(file)
	fmt.Printf("The file is %d bytes\n", l)
	fmt.Println("bytes > 100:", Chunk(file))

	ch := make(chan int)
	c := l / 10
	fmt.Println("Chunk size:", c)
	for i := 0; i < 9; i++ {
		tmp := file[:c]
		go ChanChunk(tmp, ch)
		file = file[c:]
	}
	go ChanChunk(file, ch)

	tot := 0
	for i := 0; i < 10; i++ {
		tot += <-ch
	}
	fmt.Println(tot)

}


func ChanChunk(data []byte, ch chan int){
	res := 0
	for _, v := range data{
		if v >100{
			res++
		}
	}
	ch <-res
}



//this is a chunk
func Chunk(data []byte) int {
	res := 0
	for _, v := range data {
		if v > 100 {
			res++
		}
	}
	return res
}
